#!/system/bin/sh

ATH="`lsmod | busybox grep ^"ath" `"
ATH9K_HW="`lsmod | busybox grep ^"ath9k_hw" `"
ATH9K_HTC="`lsmod | busybox grep ^"ath9k_htc" `"
ATH9K_COMM="`lsmod | busybox grep ^"ath9k_common" `"
CFG80211="`lsmod | busybox grep ^"cfg80211" `"
MAC80211="`lsmod | busybox grep ^"mac80211" `"
COMPAT="`lsmod | busybox grep ^"compat" `"
KFIFO="`lsmod | busybox grep ^"kfifo" `"

case $1 in
  	load)
				insmod /system/lib/modules/`busybox uname -r`/atheros/compat.ko
				insmod /system/lib/modules/`busybox uname -r`/atheros/kfifo.ko
				insmod /system/lib/modules/`busybox uname -r`/atheros/cfg80211.ko
				insmod /system/lib/modules/`busybox uname -r`/atheros/mac80211.ko
				insmod /system/lib/modules/`busybox uname -r`/atheros/ath.ko
				insmod /system/lib/modules/`busybox uname -r`/atheros/ath9k/ath9k_hw.ko
				insmod /system/lib/modules/`busybox uname -r`/atheros/ath9k/ath9k_common.ko
				insmod /system/lib/modules/`busybox uname -r`/atheros/ath9k/ath9k_htc.ko
		;;

		unload)
		  if [ -n "$ATH9K_HTC" ];then
				rmmod ath9k_htc.ko		
			fi	
		  if [ -n "$ATH9K_COMM" ];then
				rmmod ath9k_common.ko
			fi	
		  if [ -n "$ATH9K_HW" ];then
				rmmod ath9k_hw.ko
			fi
		  if [ -n "$ATH" ];then
				rmmod ath.ko
			fi
		  if [ -n "$MAC80211" ];then
				rmmod mac80211.ko
			fi
		  if [ -n "$CFG80211" ];then
				rmmod cfg80211.ko
			fi
		  if [ -n "$KFIFO" ];then
				rmmod kfifo.ko
			fi
		  if [ -n "$COMPAT" ];then
				rmmod compat.ko
			fi
		;;	
esac	